﻿using System.Reflection;
using HarmonyLib;
using UnityModManagerNet;

namespace ADOFAIAsyncInput
{
    internal static class AsyncInputMod
    {
        private static Harmony _harmony;

        internal static UnityModManager.ModEntry Entry;
        
        private static void Load(UnityModManager.ModEntry entry)
        {
            Entry = entry;
            
            _harmony = new Harmony(entry.Info.Id);
            
            entry.OnToggle = (_, b) =>
            {
                if (b)
                {
                    _harmony.PatchAll(Assembly.GetExecutingAssembly());

                    if (Persistence.GetChosenAsynchronousInput())
                    {
                        Patches.StartThread();
                        Entry.Logger.Log("Started Hook");
                        RDInput.OnAsyncInputToggle(true);
                    }
                }
                else
                {
                    Patches.Thread.Abort();
                    Entry.Logger.Log("Stopped Hook");
                    Patches.Thread = null;

                    _harmony.UnpatchAll(_harmony.Id);
                }
                return true;
            };
        }
    }
}