using System.IO;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace ADOFAIAsyncInput
{
    public class AsyncInputNative
    {
        [StructLayout(LayoutKind.Sequential)]
        public struct CallbackData
        {
            public EventType event_type;
            public int key;
        }

        public enum EventType
        {
            Press,
            Release,
        }
        
        public delegate void Callback(
            CallbackData data);

        public static void Copy()
        {
        }

        [ModuleInitializer]
        internal static void LoadLib()
        {
            // var executingAssembly = Assembly.GetExecutingAssembly();
            //
            // using var stream = executingAssembly.GetManifestResourceStream("ADOFAIAsyncInput.natives.asyncinput.dll")!;
            //
            // byte[] numArray = new byte[stream.Length];
            // _ = stream.Read(numArray, 0, numArray.Length);
            // File.WriteAllBytes("asyncinput.dll", numArray);
        }

        private const string Lib = "Mods\\AsyncInput\\natives\\asyncinput";

        [DllImport(Lib, EntryPoint = "run", CallingConvention = CallingConvention.Cdecl)]
        public static extern void RunHook(Callback callback);

        [DllImport(Lib, EntryPoint = "stop", CallingConvention = CallingConvention.Cdecl)]
        public static extern void Stop();
    }
}