﻿using System;
using System.Runtime.InteropServices;
using System.Threading;

namespace AsyncInputTest
{
    internal static class Program
    {
        [StructLayout(LayoutKind.Sequential)]
        private struct CallbackData
        {
            public EventType event_type;
            public int key;
        }

        private enum EventType
        {
            Press,
            Release,
        }
        
        private delegate void Callback(
             CallbackData data);

        [DllImport("natives/asyncinput", EntryPoint = "run", CallingConvention = CallingConvention.Cdecl)]
        private static extern void RunHook(Callback callback);

        [DllImport("natives/asyncinput", EntryPoint = "stop", CallingConvention = CallingConvention.Cdecl)]
        private static extern void Stop();

        public static void Main()
        {
            var thread = new Thread(() =>
            {
                RunHook((v) => { Console.WriteLine($"{v.event_type} {v.key}"); });
            });
            
            thread.Start();

            Console.WriteLine("Started!");
            
            Thread.Sleep(TimeSpan.FromDays(1));
        }
    }
}